/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOnigasm = void 0;
var onigasmLib = null;
function getOnigasm() {
    if (!onigasmLib) {
        var onigasmModule_1 = require('onigasm');
        var onigasmIndexpath = require.resolve('onigasm');
        var fs = require('fs');
        var path = require('path');
        var wasmBin = fs.readFileSync(path.join(onigasmIndexpath, '../onigasm.wasm')).buffer;
        onigasmLib = onigasmModule_1.loadWASM(wasmBin).then(function (_) {
            return {
                createOnigScanner: function (patterns) {
                    return new onigasmModule_1.OnigScanner(patterns);
                },
                createOnigString: function (s) {
                    return new onigasmModule_1.OnigString(s);
                }
            };
        });
    }
    return onigasmLib;
}
exports.getOnigasm = getOnigasm;
//# sourceMappingURL=onigLibs.js.map