"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderToHtml = void 0;
function renderToHtml(lines, options) {
    if (options === void 0) { options = {}; }
    var bg = options.bg || '#fff';
    var html = '';
    html += "<pre class=\"shiki\" style=\"background-color: " + bg + "\">";
    if (options.langId) {
        html += "<div class=\"language-id\">" + options.langId + "</div>";
    }
    html += "<code>";
    lines.forEach(function (l) {
        if (l.length === 0) {
            html += "\n";
        }
        else {
            l.forEach(function (token) {
                html += "<span style=\"color: " + (token.color || options.fg) + "\">" + escapeHtml(token.content) + "</span>";
            });
            html += "\n";
        }
    });
    html = html.replace(/\n*$/, ''); // Get rid of final new lines
    html += "</code></pre>";
    return html;
}
exports.renderToHtml = renderToHtml;
var htmlEscapes = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#39;'
};
function escapeHtml(html) {
    return html.replace(/[&<>"']/g, function (chr) { return htmlEscapes[chr]; });
}
//# sourceMappingURL=renderer.js.map